﻿package logica{
	import flash.display.MovieClip;

	public class Cancion extends MovieClip {
		import flash.events.*;
		import flash.utils.*;
		import flash.media.*;
		import persistencia.ControladorFichero;
		import logica.Cursor;

		public static  const ACCION_TERMINADA:String = "accionTerminada";
		public static  const CANCION_COMPUESTA:String = "cancionCompuesta";
		public static  const CURSOR_AVISAR:String = "cursorAvisar";
		private var relPartituraInstrumento = new Array();//relacion entre num. de partitura e instrumento asociado
		private var cf:ControladorFichero;
		private var c:Controlador;
		private var listaPartituras:Array = new Array();
		private var contenedorCancion:MovieClip;
		private var cursor:Cursor;

		//Para la demostración
		private var listaSonidoInstrumentos:Array;
		private var numFiguraActual:Array=new Array();
		private var numPartituraActual:int;
		private var repPartitura:Array=new Array();

		private var listaPosicionFiguras:Array = new Array();//contiene las x de las figuras. Contiene un Array por partitura

		private var repeticiones:int;
		private var numInstrumentos:int;
		private var numCompases:int;
		private var tiempoCompas:int;
		private var numFiguras:int=0;
		private var posfinal:int;

		//En el caso que estemos en el juego
		private var sonido:Sound;
		private var sc:SoundChannel;


		//los atributos siguientes se utilizan en la composicion de la canción
		private var ycomun=50;
		private var xcomp=0;
		private var comp=0;
		private var tiempo=0.0;
		private var dcorchea=20;


		public function Cancion(numInst:int,ap:Array,rep:int,dCorchea:int,vel:Number):void {

			c=Controlador.getControlador();
			contenedorCancion=new MovieClip();
			numInstrumentos=numInst;
			repeticiones=rep;
			dcorchea=dCorchea;
			for (var i=0; i<numInstrumentos; i++) {
				listaPartituras.push(new MovieClip());
				listaPosicionFiguras.push(new Array());
			}
			leerArrayPartituras(ap);//el array contiene las figuras, en la penúltima posición tiene el número de compases y en la última el tiempo de compas.
			componerCancion();
			cursor= new Cursor(numInstrumentos,getPosFinal()+c.getCentradoCancion()+200,rep,vel);//los 200 por el espacio que deja Cancion para meter los iconos.

		}
		//Para la academia
		public static function getCancionesNivel(niv:int):Array {
			var ret:Array = new Array();
			var aPartituras:Array;
			switch (niv) {

				case 1 :
					aPartituras= new Array("b,b,b,b,4,2,");
					var can1:Cancion = new Cancion(1,aPartituras,1,40,2);


					aPartituras= new Array("n,n,n,n,n,n,n,n,4,2,");
					var can2:Cancion = new Cancion(1,aPartituras,1,40,2);
					ret.push(can1,can2);

					break;

				case 2 :
					aPartituras= new Array("n,cc,n,cc,n,cc,n,cc,4,2,");
					var can3:Cancion = new Cancion(1,aPartituras,1,40,2);
					ret.push(can3);

					break;
				case 3 :
					aPartituras= new Array("n,sn,n,sn,n,sn,n,sn,","sn,n,sn,n,sn,n,sn,n,4,2,");
					var can4:Cancion = new Cancion(2,aPartituras,1,40,2);
					ret.push(can4);
					break;

				case 4 :
					aPartituras= new Array("n,sn,n,n,sn,n,n,sn,n,n,sn,n","sn,n,sn,sn,n,sn,sn,n,sn,sn,n,sn,4,3,");
					var can5:Cancion = new Cancion(2,aPartituras,1,40,2);
					ret.push(can5);
					break;


				default :
					break;

			}
			return ret;
		}

		//Para el juego
		public static function getCancion(n:String,nv:int):Cancion {
			var ret:Cancion;
			var aPartituras:Array;
			switch (nv) {

				case 1 :
					aPartituras= new Array("r,r,r,r,4,4,");
					break;

				case 2 :
					aPartituras= new Array("b,b,r,b,b,r,4,4,");
					break;

				case 3 :
					aPartituras= new Array("b,n,n,b,b,b,n,n,b,b,4,4,");
					break;

				default :
					trace("error getCancion");
					break;



			}
			switch (n) {

				case "muñeca" :
					ret = new Cancion(1,aPartituras,2,20,2.65);
					ret.asignarMusica(new cancionmuñeca());
					break;

				case "burro" :
					ret = new Cancion(1,aPartituras,2,20,2.7);
					ret.asignarMusica(new cancionburro());
					break;
				case "vaca" :
					ret = new Cancion(1,aPartituras,2,20,2.6);
					ret.asignarMusica(new cancionvaca());
					break;
				case "gallina" :
					ret = new Cancion(1,aPartituras,2,20,2.9);
					ret.asignarMusica(new canciongallina());
				default :
					break;


			}
			return ret;
		}
		public function asignarMusica(s:Sound) {
			sonido=s;
		}
		public function empezarCancion() {
			sonido.play();
		}



		public function leerArrayPartituras(arraypartituras) {

			var i,j=int;

			var aux:Array=arraypartituras[arraypartituras.length-1].split(',');
			tiempoCompas=aux[aux.length-2];
			numCompases=aux[aux.length-3];
			for (j=0; j<arraypartituras.length; j++) {
				var arraynotas=arraypartituras[j].split(',');

				ycomun=50;//se inicializa para la siguiente partitura
				xcomp=0;
				comp=0;
				tiempo=0.0;


				for (i=0; i<arraynotas.length; i++) {
					switch (arraynotas[i]) {//Tratamiento de las figuras
						case "r" :
							var redonda:Redonda=new Redonda();
							redonda.name="componente"+comp.toString();
							comp++;
							redonda.y=ycomun;
							redonda.x=xcomp;
							xcomp+=dcorchea*8;
							tiempo+=4;
							listaPartituras[j].addChild(redonda);
							listaPosicionFiguras[j].push(redonda.x);



							break;

						case "bp" :
							var blancap:Blancapuntillo=new Blancapuntillo();
							blancap.name="componente"+comp.toString();
							comp++;
							blancap.y=ycomun;
							blancap.x=xcomp;
							xcomp+=dcorchea*6;
							tiempo+=3;
							listaPartituras[j].addChild(blancap);
							listaPosicionFiguras[j].push(blancap.x);

							break;

						case "b" :
							var blanca:Blanca=new Blanca();
							blanca.name="componente"+comp.toString();
							comp++;
							blanca.y=ycomun;
							blanca.x=xcomp;
							xcomp+=dcorchea*4;
							tiempo+=2;
							listaPartituras[j].addChild(blanca);
							listaPosicionFiguras[j].push(blanca.x);



							break;

						case "n" :
							var negra:Negra=new Negra();
							negra.name="componente"+comp.toString();
							comp++;
							negra.y=ycomun;
							negra.x=xcomp;
							xcomp+=dcorchea*2;
							tiempo+=1;
							listaPartituras[j].addChild(negra);
							listaPosicionFiguras[j].push(negra.x);



							break;

						case "cc" :
							var doscorcheas1:Doscorcheas1=new Doscorcheas1();
							var doscorcheas2:Doscorcheas2=new Doscorcheas2();
							doscorcheas1.name="componente"+comp.toString();
							comp++;
							doscorcheas2.name="componente"+comp.toString();
							comp++;
							doscorcheas1.y=ycomun;
							doscorcheas1.x=xcomp;
							doscorcheas2.y=ycomun;
							doscorcheas2.x=xcomp+dcorchea-4;
							xcomp+=dcorchea*2;
							tiempo+=1;
							listaPartituras[j].addChild(doscorcheas1);
							listaPartituras[j].addChild(doscorcheas2);
							listaPosicionFiguras[j].push(doscorcheas1.x);
							listaPosicionFiguras[j].push(doscorcheas1.x+dcorchea);

							break;

						case "c" :
							var corchea:Corchea=new Corchea();
							corchea.name="componente"+comp.toString();
							comp++;
							corchea.y=ycomun;
							corchea.x=xcomp;
							xcomp+=dcorchea;
							tiempo+=0.5;
							listaPartituras[j].addChild(corchea);
							listaPosicionFiguras[j].push(corchea.x);


							break;

							//Tratamiento de los silencios "invisibles"
						case "sr" :
							xcomp+=dcorchea*8;
							tiempo+=4;
							break;

						case "sbp" :
							xcomp+=dcorchea*6;
							tiempo+=3;
							break;

						case "sb" :
							xcomp+=dcorchea*4;
							tiempo+=2;
							break;

						case "sn" :
							xcomp+=dcorchea*2;
							tiempo+=1;
							break;

						case "sc" :
							xcomp+=dcorchea;
							tiempo+=0.5;
							break;


							//tratamiento de los silencios "visibles"
						case "srv" :
							var sredonda:Sredonda=new Sredonda();
							sredonda.name="componente"+comp.toString();
							comp++;
							sredonda.y=ycomun;
							sredonda.x=xcomp;
							xcomp+=dcorchea*8;
							tiempo+=4;
							listaPartituras[j].addChild(sredonda);
							break;

						case "sbpv" :
							var sblancap:Sblancapuntillo=new Sblancapuntillo();
							sblancap.name="componente"+comp.toString();
							comp++;
							sblancap.y=ycomun;
							sblancap.x=xcomp;
							xcomp+=dcorchea*6;
							tiempo+=3;
							listaPartituras[j].addChild(sblancap);
							break;


						case "sbv" :
							var sblanca:Sblanca=new Sblanca();
							sblanca.name="componente"+comp.toString();
							comp++;
							sblanca.y=ycomun;
							sblanca.x=xcomp;
							xcomp+=dcorchea*4;
							tiempo+=2;
							listaPartituras[j].addChild(sblanca);
							break;

						case "snv" :
							var snegra:Snegra=new Snegra();
							snegra.name="componente"+comp.toString();
							comp++;
							snegra.y=ycomun;
							snegra.x=xcomp;
							xcomp+=dcorchea*2;
							tiempo+=1;
							listaPartituras[j].addChild(snegra);
							break;

						case "scv" :
							var scorchea:Scorchea=new Scorchea();
							scorchea.name="componente"+comp.toString();
							comp++;
							scorchea.y=ycomun;
							scorchea.x=xcomp;
							xcomp+=dcorchea;
							tiempo+=0.5;
							listaPartituras[j].addChild(scorchea);
							break;

						default :
							break;
					}//switch
					if (tiempo == tiempoCompas) {
						pintarcompas(j);
					}
				}//for notas
				xcomp+=5;
				pintarcompas(j);//para conseguir el doble compas final

			}//for partituras
			posfinal=xcomp-5;
			//Contamos las figuras
			for (i=0; i<listaPosicionFiguras.length; i++) {
				for (var k=0; k<listaPosicionFiguras[i].length; k++) {
					numFiguras++;


				}//for
			}//for




		}
		private function pintarcompas(numpartitura:int):void {
			var compas:Compas=new Compas();
			compas.name="componente"+comp.toString();
			comp++;
			compas.y=ycomun;
			compas.x=xcomp-5;
			tiempo=0;
			listaPartituras[numpartitura].addChild(compas);

		}
		private function pintardospuntos(numpartitura:int):void {
			var dospuntos:Dospuntos=new Dospuntos();
			dospuntos.name="componente"+comp.toString();
			comp++;
			dospuntos.y=ycomun;
			dospuntos.x=xcomp-15;
			listaPartituras[numpartitura].addChild(dospuntos);

		}
		public function componerCancion() {
			var partitura:MovieClip;
			var partituraSilencios:MovieClip;
			var tiempoCompasMC:MovieClip;
			var ypartitura=5;
			var xpartitura=200;//movemos las partituras de x=0 para meter los iconos
			var posicionLineasH= new Array(100,220,340,460);
			var anchuraLineasH= new Array(80,120,160);
			var posicionTiempoCompas= new Array(60,130,200,250);
			var componente=0;
			var contador=0;



			//colocamos solo las partituras
			for (var i = 0; i<listaPartituras.length; i++) {
				partitura=listaPartituras[i];
				partitura.y=ypartitura;
				partitura.x=xpartitura;
				contenedorCancion.addChild(partitura);
				ypartitura+=120;
			}
			ypartitura=5;

			//colocamos el tiempo del compas
			switch (tiempoCompas) {
				case 2 :
					tiempoCompasMC = new Dosporcuatro();

					break;

				case 3 :
					tiempoCompasMC = new Tresporcuatro();

					break;

				case 4 :
					tiempoCompasMC = new Cuatroporcuatro();

					break;

				default :

			}
			tiempoCompasMC.y=posicionTiempoCompas[numInstrumentos-1];
			tiempoCompasMC.x=90;

			contenedorCancion.addChild(tiempoCompasMC);

			//colocamos las lineas politimbricas solo si es necesario
			if ( numInstrumentos!=1) {
				for (i = 0; i<numInstrumentos; i++) {
					var lineaH:LineaH = new LineaH();
					lineaH.name="componente"+componente.toString();
					componente++;
					lineaH.x=xpartitura;
					lineaH.y=posicionLineasH[i];
					lineaH.width=getPosFinal();
					contenedorCancion.addChild(lineaH);

				}
			}
			//colocamos los iconos. 
			listaSonidoInstrumentos=new Array();


			if (c.checkInstr("triangulo")) {

				var iconoTriangulo:IconotrianguloMC=new IconotrianguloMC();
				iconoTriangulo.y=posicionLineasH[contador];
				contenedorCancion.addChild(iconoTriangulo);
				listaSonidoInstrumentos.push(new sonidotriangulo());
				relPartituraInstrumento.push("triangulo");
				contador++;

			}
			if (c.checkInstr("claves")) {
				var iconoClaves:IconoclavesMC=new IconoclavesMC();
				iconoClaves.y=posicionLineasH[contador];
				contenedorCancion.addChild(iconoClaves);
				listaSonidoInstrumentos.push(new sonidoclaves());
				relPartituraInstrumento.push("claves");
				contador++;

			}
			if (c.checkInstr("pandero")) {
				var iconoPandero:IconopanderoMC=new IconopanderoMC();
				iconoPandero.y=posicionLineasH[contador];
				contenedorCancion.addChild(iconoPandero);
				listaSonidoInstrumentos.push(new sonidopandero());
				relPartituraInstrumento.push("pandero");
				contador++;


			}
			if (c.checkInstr("crotalos")) {
				var iconoCrotalos:IconocrotalosMC=new IconocrotalosMC();
				iconoCrotalos.y=posicionLineasH[contador];
				contenedorCancion.addChild(iconoCrotalos);
				listaSonidoInstrumentos.push(new sonidocrotalos());
				relPartituraInstrumento.push("crotalos");
				contador++;

			}
			if (c.checkInstr("bombo")) {
				var iconoTambor:IconotamborMC=new IconotamborMC();
				iconoTambor.y=posicionLineasH[contador];
				contenedorCancion.addChild(iconoTambor);
				listaSonidoInstrumentos.push(new sonidotambor());
				relPartituraInstrumento.push("bombo");

				contador++;

			}
			if (c.checkInstr("caja")) {
				var iconoCaja:IconocajaMC=new IconocajaMC();
				iconoCaja.y=posicionLineasH[contador];
				contenedorCancion.addChild(iconoCaja);
				listaSonidoInstrumentos.push(new sonidocaja());
				relPartituraInstrumento.push("caja");

				contador++;

			}
			if (c.checkInstr("charles")) {
				var iconoCharles:IconocharlesMC=new IconocharlesMC();
				iconoCharles.y=posicionLineasH[contador];
				contenedorCancion.addChild(iconoCharles);
				listaSonidoInstrumentos.push(new sonidocharles());
				relPartituraInstrumento.push("charles");
				contador++;

			}
			if (c.checkInstr("plato")) {
				var iconoPlato:IconoplatoMC=new IconoplatoMC();
				iconoPlato.y=posicionLineasH[contador];
				contenedorCancion.addChild(iconoPlato);
				listaSonidoInstrumentos.push(new sonidoplato());
				relPartituraInstrumento.push("plato");
				contador++;

			}
		}//END COMPONERCANCION


		public function getContenedorCancion():MovieClip {
			return contenedorCancion;

		}
		public function getPosFinal():int {
			return posfinal;

		}

		public function demo() {
			var s:Sound;
			var sc:SoundChannel = new SoundChannel();
			c.escucharVisible(false);

			for (var i=0; i<numInstrumentos; i++) {//Inicializamos

				numFiguraActual[i]=0;
			}
			var avisarX = 2000;//la primera figura, este en la partitura que este, estará en la posición 0. Ponemos avisarX a 1 para que la encuentre.
			var aux:int;

			for (i=0; i<numInstrumentos; i++) {//Obtenemos la posición de la figura a tocar que será la mínima de entre las partituras,

				aux=listaPosicionFiguras[i][numFiguraActual[i]];
				if (aux<avisarX) {
					avisarX=aux;
					numPartituraActual=i;

				}
			}

			cursor.setAvisarEnX(avisarX+10);//+10 para que toque en MEDIO de la figura
			cursor.addEventListener(CURSOR_AVISAR,avisado);


		}

		private function avisado(e:Event) {

			listaSonidoInstrumentos[numPartituraActual].play();
			cursor.removeEventListener(CANCION_COMPUESTA, avisado);


			numFiguraActual[numPartituraActual]++;;
			if (listaPosicionFiguras[numPartituraActual].length==numFiguraActual[numPartituraActual]) {

				cursor.setAvisarEnX(-1);
			}
			var aux;
			var avisarX=2000;
			for (var i=0; i<numInstrumentos; i++) {//Obtenemos la posición de la figura a tocar que será la mínima de entre las partituras,

				aux=listaPosicionFiguras[i][numFiguraActual[i]];
				if ((aux<avisarX)&&(cursor.getPosRelativa()<aux)) {
					avisarX=aux;
					numPartituraActual=i;

				}
			}//for

			if (avisarX!=2000) {

				cursor.setAvisarEnX(avisarX+10);
				cursor.addEventListener(CURSOR_AVISAR,avisado);

			} else {//hemos acabado
				c.escucharVisible(true);

			}
		}
		public function getNumFiguras():int {

			return numFiguras;

		}
		public function getListaPosicionFiguras():Array {

			return listaPosicionFiguras;

		}
		public function getRelPartituraInstrumento():Array {

			return relPartituraInstrumento;

		}


		public function getCursor():Cursor {

			return cursor;

		}
	}//class
}//package