﻿package logica{

	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.geom.ColorTransform;
	import flash.events.*;
	import flash.media.*;
	import flash.utils.*;

	public class Juego extends MovieClip {

		private var cancion:Cancion;
		private var cursor:Cursor;
		private var c:Controlador=Controlador.getControlador();
		private var tituloCancion:String;

		private var tiempoIntro:int;
		private var tiempoCursor:int;
		private var tiempo:Timer=new Timer(1000);
		private var velocidad:Number;

		private var puntuacionActual:int;
		private var puntuacionMax:int;
		private var f_error=0.5;
		private var estrellas:int;
		private var contador:int;

		private var numFiguraActual:int;
		private var posicionFiguras:Array;

		private var contenedorEstrellas:MovieClip;


		public function Juego() {


		}




		public function inicializar(n:String) {
			tituloCancion=n;
			var nv=c.checkNivelActual();
			switch (n) {

				case "muñeca" :
					cancion=Cancion.getCancion(n,nv);
					tiempoCursor=6000;
					tiempoIntro=8000;
					break;
				case "burro" :
					cancion=Cancion.getCancion(n,nv);
					tiempoCursor=6200;
					tiempoIntro=8150;
					break;
				case "vaca" :
					cancion=Cancion.getCancion(n,nv);
					tiempoCursor=5900;
					tiempoIntro=8000;
					break;
				case "gallina" :
					cancion=Cancion.getCancion(n,nv);
					tiempoCursor=6000;
					tiempoIntro=7900;
					break;
				default :
					trace("fallo en creación Juego");
					break;


			}//switch
			cursor=cancion.getCursor();
			posicionFiguras=cancion.getListaPosicionFiguras();
			puntuacionMax=cancion.getNumFiguras()*30*2;//*2 porque hay dos repeticiones
			ControladorVista(root).añadirCancionyCursor(cancion.getContenedorCancion(),cursor.getCursorMC());
			stage.frameRate=30;
		}

		public function reiniciar() {
			tiempo.removeEventListener(TimerEvent.TIMER, introFin);
			tiempo.removeEventListener(TimerEvent.TIMER, cursorEmpieza);
			cursor.parar();
		}
		public function escucharCancion() {
			cancion.empezarCancion();
			tiempo= new Timer(tiempoIntro);//Introduccion de la cancion
			tiempo.addEventListener(TimerEvent.TIMER, introFin);
			tiempo.start();

		}
		public function tocarCancion() {
			cancion.empezarCancion();
			tiempo= new Timer(tiempoCursor);//Introduccion de la cancion
			tiempo.addEventListener(TimerEvent.TIMER, cursorEmpieza);
			tiempo.start();

		}
		public function mostrarPuntuacion() {
			contenedorEstrellas=new MovieClip();
			var ratio= puntuacionActual/puntuacionMax;
			ControladorVista(root).txtPuntuacion.text=puntuacionActual+"/"+puntuacionMax;
			if (ratio>0.2) {
				estrellas=1;
			}
			if (ratio>0.4) {
				estrellas=2;
			}
			if (ratio>0.6) {
				estrellas=3;
			}
			if (ratio>0.8) {
				estrellas=4;
			}
			if (ratio>0.9) {
				estrellas=5;
			}
			tiempo= new Timer(500,estrellas);
			tiempo.addEventListener(TimerEvent.TIMER, pintaEstrella);
			tiempo.start();

			addChild(contenedorEstrellas);
			var s:Sound = new sonidoaplausos();
			var sc:SoundChannel=new SoundChannel();
			sc=s.play();
			sc.addEventListener(Event.SOUND_COMPLETE, finAplausos);



		}
		private function finAplausos(e:Event) {
			var s:Sound;
			var sc:SoundChannel=new SoundChannel();

			if (estrellas==5) {
				s=new sonido5estrellas();
				var cop:MovieClip= new copa();
				cop.x=732.4;cop.y=510.9;
				contenedorEstrellas.addChild(cop);
				c.setCopa();

			} else {
				s=new sonidobienpuntuacion();


			}
			sc=s.play();
			ControladorVista(root).percusitoJuego.play();
			sc.addEventListener(Event.SOUND_COMPLETE, callar);

		}
		private function callar(e:Event) {
			ControladorVista(root).percusitoJuego.stop();
			ControladorVista(root).btnsiguiente.visible=true;

		}
		private function introFin(e:TimerEvent) {
			e.target.removeEventListener(TimerEvent.TIMER, introFin);

			cancion.demo();
			cursor.demo();

		}
		private function cursorEmpieza(e:TimerEvent) {
			e.target.removeEventListener(TimerEvent.TIMER, cursorEmpieza);
			cursor.empezar();

		}
		public function repetirDemo() {
			cancion.demo();
		}
		private function pintaEstrella(e:TimerEvent) {

			var pintadas:int;
			var faltan:int;
			var posX:Array=new Array(624,681,738,796,857);
			var estrella:MovieClip=new estrellanivel();
			
			estrella.y=604.5;
			estrella.x=posX[contador];
			contenedorEstrellas.addChild(estrella);
			contador++;
		}
		public function instrumentoPulsado(btn:String) {

			var posCorrecta = posicionFiguras[0][numFiguraActual]+10;

			var posPulsada = cursor.getPosRelativa();

			var error=Math.abs(posCorrecta-posPulsada);
			
			if (error<=10){
				puntuacionActual+=30;
				
				
			}else if (error <30 && error >10) {

				puntuacionActual+=30-error*f_error;

			}
			numFiguraActual++;
			if (numFiguraActual == posicionFiguras[0].length) {

				numFiguraActual=0;

			}
		}
		
		
		public function borrarEstrellas(){
			
			removeChild(contenedorEstrellas);
			
		}
	}//clase
}//package